<?php
namespace Odhen\API\Remote\Printer;

use Odhen\API\Remote\Printer\Command;
use Zeedhi\Framework\Remote\Exception;

class Printing {

    public $curl;
    public $baseUrl;
    public $printerProperties;
    public $command;
    public $util;

    public function __construct($curl, Command $command, $util_) {
        $this->curl = $curl;
        $this->command = $command;
        $this->util = $util_;
    }

    public function setPrinterProperties(array $printerProperties) {
        $this->printerProperties = $printerProperties;
        return $this;
    }

    public function setUrl($url) {
        $this->util->geraLog2("setUrl ".$url,null,null,"EnvioPerifericos");
    	$this->curl->setBaseUrl($url);
        $this->baseUrl = $url;
    }

    public function sendPrint() {
        try {
            $this->util->geraLog2("sendPrint",null,null,"EnvioPerifericos");
            if(empty($this->baseUrl)){
                $this->util->geraLog2("O endereço do Periféricos cadastrado para a impressora esta vazio.",null,null,"EnvioPerifericos");
				try {
					$this->util->geraLog2("printerProperties: ".print_r($this->printerProperties,true),null,null,"EnvioPerifericos");
				}  catch(Exception $e) {
					$this->util->geraLog2("printerProperties: undefined",null,null,"EnvioPerifericos");
				}
                throw new \Exception('O endereço do Periféricos cadastrado para a impressora esta vazio.');
            }
            $this->util->geraLog2("Url ".$this->baseUrl,null,null,"EnvioPerifericos");
            $this->util->geraLog2("printerProperties: ".print_r($this->printerProperties,true),null,null,"EnvioPerifericos");
            $this->util->geraLog2("commands: ".print_r($this->command->getCommands(),true),null,null,"EnvioPerifericos");
            $result = $this->curl->request('/print', array(
                'printerInfo' => $this->printerProperties,
                'commands' => $this->command->getCommands()
            ));
            $this->util->geraLog2("resultJson: ".print_r($result,true),null,null,"EnvioPerifericos");
            $resultJson = json_decode($result, true);
            if ($resultJson['error']) {
                throw new \Exception($resultJson['message']);
            } else if ($resultJson == null) {
            	throw new \Exception($result);
            }
            return $resultJson;
        }  catch(Exception $e) {
            $this->util->geraLog2($e->getMessage(),null,null,"EnvioPerifericos");
            throw new \Exception('Endereço do Periféricos inválido ou se encontra desligado.');
        } catch(\Exception $e) {
            $this->util->geraLog2($e->getMessage(),null,null,"EnvioPerifericos");
            throw $e;
        }
    }

    public function testPrint() {
        try {
            $this->util->geraLog2("sendPrint",null,null,"EnvioPerifericos");
            if(empty($this->baseUrl)){
                $this->util->geraLog2("O endereço do Periféricos cadastrado para a impressora esta vazio.",null,null,"EnvioPerifericos");
				try {
					$this->util->geraLog2("testPrint printerProperties: ".print_r($this->printerProperties,true),null,null,"EnvioPerifericos");
				}  catch(Exception $e) {
					$this->util->geraLog2("testPrint printerProperties: undefined",null,null,"EnvioPerifericos");
				}
                throw new \Exception('O endereço do Periféricos cadastrado para a impressora esta vazio.');
            }
            $this->util->geraLog2("Url ".$this->baseUrl,null,null,"EnvioPerifericos");
            $this->util->geraLog2("printerProperties: ".print_r($this->printerProperties,true),null,null,"EnvioPerifericos");
            $result = $this->curl->request('/test', array(
                'printerInfo' => $this->printerProperties
            ));
            $this->util->geraLog2("resultJson: ".print_r($result,true),null,null,"EnvioPerifericos");
            $resultJson = json_decode($result, true);
            if ($resultJson['error']) {
                throw new \Exception($resultJson['message']);
            } else if ($resultJson == null) {
                throw new \Exception($result);
            }
            return $resultJson;
        }  catch(Exception $e) {
            $this->util->geraLog2($e->getMessage(),null,null,"EnvioPerifericos");
            throw new \Exception('Endereço do Periféricos inválido ou se encontra desligado.');
        } catch(\Exception $e) {
            $this->util->geraLog2($e->getMessage(),null,null,"EnvioPerifericos");
            throw $e;
        }
    }
}